]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
Merge branch 'jt/batch-fetch-blobs-in-diff'
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
68cabbfd
DL
8USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 11 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
b57e8119 14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
adc54235 15 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 16 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
17 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
18 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 19OPTIONS_SPEC=
091a6eb0 20SUBDIRECTORY_OK=Yes
70c7ac22 21. git-sh-setup
98fcf840 22. git-parse-remote
70c7ac22 23require_work_tree
091a6eb0
JK
24wt_prefix=$(git rev-parse --show-prefix)
25cd_to_toplevel
70c7ac22 26
f1762d77
BW
27# Tell the rest of git that any URLs we get don't come
28# directly from the user, so it can apply policy as appropriate.
29GIT_PROTOCOL_FROM_USER=0
30export GIT_PROTOCOL_FROM_USER
33cfccbb 31
5c08dbbd 32command=
ecda0723 33branch=
d27b876b 34force=
d92a3959 35reference=
70c7ac22 36cached=
48bb3033
GP
37recursive=
38init=
1c244f6e 39files=
06b1abb5 40remote=
31ca3ac3 41nofetch=
32948425 42update=
15fc56a8 43prefix=
73b0898d 44custom_name=
275cd184 45depth=
72c5f883 46progress=
a0ef2934 47dissociate=
70c7ac22 48
be9d0a3a
HV
49die_if_unmatched ()
50{
51 if test "$1" = "#unmatched"
52 then
c4c02bf1 53 exit ${2:-1}
be9d0a3a
HV
54 fi
55}
56
88ce00c3
TK
57#
58# Print a submodule configuration setting
59#
60# $1 = submodule name
61# $2 = option name
62# $3 = default value
63#
64# Checks in the usual git-config places first (for overrides),
65# otherwise it falls back on .gitmodules. This allows you to
66# distribute project-wide defaults in .gitmodules, while still
67# customizing individual repositories if necessary. If the option is
68# not in .gitmodules either, print a default value.
69#
70get_submodule_config () {
71 name="$1"
72 option="$2"
73 default="$3"
74 value=$(git config submodule."$name"."$option")
75 if test -z "$value"
76 then
b2faad44 77 value=$(git submodule--helper config submodule."$name"."$option")
88ce00c3
TK
78 fi
79 printf '%s' "${value:-$default}"
80}
81
862ae6cd
RS
82isnumber()
83{
84 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
85}
86
dda63468 87# Given a full hex object ID, is this the zero OID?
88is_zero_oid () {
89 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
90}
91
14111fc4
JK
92# Sanitize the local git environment for use within a submodule. We
93# can't simply use clear_local_git_env since we want to preserve some
94# of the settings from GIT_CONFIG_PARAMETERS.
95sanitize_submodule_env()
96{
89044baa 97 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 98 clear_local_git_env
89044baa 99 GIT_CONFIG_PARAMETERS=$save_config
860cba61 100 export GIT_CONFIG_PARAMETERS
14111fc4
JK
101}
102
ecda0723
SV
103#
104# Add a new submodule to the working tree, .gitmodules and the index
105#
ec05df35 106# $@ = repo path
ecda0723
SV
107#
108# optional branch is stored in global branch variable
109#
23a485e3 110cmd_add()
ecda0723 111{
5c08dbbd 112 # parse $args after "submodule ... add".
091a6eb0 113 reference_path=
5c08dbbd
JH
114 while test $# -ne 0
115 do
116 case "$1" in
117 -b | --branch)
118 case "$2" in '') usage ;; esac
119 branch=$2
120 shift
121 ;;
d27b876b
JL
122 -f | --force)
123 force=$1
124 ;;
5c08dbbd 125 -q|--quiet)
2e6a30ef 126 GIT_QUIET=1
5c08dbbd 127 ;;
6d33e1c2
CF
128 --progress)
129 progress=1
130 ;;
d92a3959
MT
131 --reference)
132 case "$2" in '') usage ;; esac
091a6eb0 133 reference_path=$2
d92a3959
MT
134 shift
135 ;;
136 --reference=*)
091a6eb0 137 reference_path="${1#--reference=}"
d92a3959 138 ;;
a0ef2934
CF
139 --dissociate)
140 dissociate=1
141 ;;
73b0898d
JL
142 --name)
143 case "$2" in '') usage ;; esac
144 custom_name=$2
145 shift
146 ;;
275cd184
FG
147 --depth)
148 case "$2" in '') usage ;; esac
149 depth="--depth=$2"
150 shift
151 ;;
152 --depth=*)
153 depth=$1
154 ;;
5c08dbbd
JH
155 --)
156 shift
157 break
158 ;;
159 -*)
160 usage
161 ;;
162 *)
163 break
164 ;;
165 esac
166 shift
167 done
168
76e9bdc4
AO
169 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
170 then
171 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
172 fi
173
091a6eb0
JK
174 if test -n "$reference_path"
175 then
176 is_absolute_path "$reference_path" ||
177 reference_path="$wt_prefix$reference_path"
178
179 reference="--reference=$reference_path"
180 fi
181
ecda0723 182 repo=$1
64394e3a 183 sm_path=$2
ecda0723 184
64394e3a 185 if test -z "$sm_path"; then
6a066230 186 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
188 fi
189
496eeeb1 190 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
191 usage
192 fi
193
091a6eb0
JK
194 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
195
ec05df35
ML
196 # assure repo is absolute or relative to parent
197 case "$repo" in
198 ./*|../*)
091a6eb0
JK
199 test -z "$wt_prefix" ||
200 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
201
ec05df35 202 # dereference source url relative to parent's url
63e95beb 203 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
204 ;;
205 *:*|/*)
206 # absolute url
207 realrepo=$repo
208 ;;
209 *)
497ee872 210 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
211 ;;
212 esac
213
db75ada5
MG
214 # normalize path:
215 # multiple //; leading ./; /./; /../; trailing /
64394e3a 216 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
217 sed -e '
218 s|//*|/|g
219 s|^\(\./\)*||
8196e728 220 s|/\(\./\)*|/|g
db75ada5
MG
221 :start
222 s|\([^/]*\)/\.\./||
223 tstart
224 s|/*$||
225 ')
619acfc7
SB
226 if test -z "$force"
227 then
228 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
229 die "$(eval_gettext "'\$sm_path' already exists in the index")"
230 else
231 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
232 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
233 fi
ecda0723 234
53213994
JK
235 if test -z "$force" &&
236 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 237 then
6ff875c5 238 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 239\$sm_path
6ff875c5 240Use -f if you really want to add it." >&2
d27b876b
JL
241 exit 1
242 fi
243
73b0898d
JL
244 if test -n "$custom_name"
245 then
246 sm_name="$custom_name"
247 else
248 sm_name="$sm_path"
249 fi
250
0383bbb9
JK
251 if ! git submodule--helper check-name "$sm_name"
252 then
253 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
254 fi
255
d4264ca3 256 # perhaps the path exists and is already a git repo, else clone it
64394e3a 257 if test -e "$sm_path"
d4264ca3 258 then
496eeeb1 259 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 260 then
64394e3a 261 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 262 else
64394e3a 263 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 264 fi
c2f93917 265
d4264ca3 266 else
4b7c286e
JL
267 if test -d ".git/modules/$sm_name"
268 then
269 if test -z "$force"
270 then
0d71dbfd 271 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 272 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
273 die "$(eval_gettextln "\
274If you want to reuse this local git directory instead of cloning again from
275 \$realrepo
276use the '--force' option. If the local git directory is not the correct repo
277or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 278 else
0d71dbfd 279 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
280 fi
281 fi
a0ef2934 282 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 283 (
14111fc4 284 sanitize_submodule_env
d851ffb9
JH
285 cd "$sm_path" &&
286 # ash fails to wordsplit ${branch:+-b "$branch"...}
287 case "$branch" in
288 '') git checkout -f -q ;;
289 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
290 esac
291 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 292 fi
73b0898d 293 git config submodule."$sm_name".url "$realrepo"
d4264ca3 294
53213994 295 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 296 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 297
b2faad44
AO
298 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
299 git submodule--helper config submodule."$sm_name".url "$repo" &&
b9289227
TK
300 if test -n "$branch"
301 then
b2faad44 302 git submodule--helper config submodule."$sm_name".branch "$branch"
b9289227 303 fi &&
31991b02 304 git add --force .gitmodules ||
64394e3a 305 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
306
307 # NEEDSWORK: In a multi-working-tree world, this needs to be
308 # set in the per-worktree config.
309 if git config --get submodule.active >/dev/null
310 then
311 # If the submodule being adding isn't already covered by the
312 # current configured pathspec, set the submodule's active flag
313 if ! git submodule--helper is-active "$sm_path"
314 then
315 git config submodule."$sm_name".active "true"
316 fi
317 else
318 git config submodule."$sm_name".active "true"
319 fi
ecda0723
SV
320}
321
19a31f9c
ML
322#
323# Execute an arbitrary command sequence in each checked out
324# submodule
325#
326# $@ = command to execute
327#
328cmd_foreach()
329{
1d5bec8b
JH
330 # parse $args after "submodule ... foreach".
331 while test $# -ne 0
332 do
333 case "$1" in
334 -q|--quiet)
335 GIT_QUIET=1
336 ;;
15fc56a8
JH
337 --recursive)
338 recursive=1
339 ;;
1d5bec8b
JH
340 -*)
341 usage
342 ;;
343 *)
344 break
345 ;;
346 esac
347 shift
348 done
349
fc1b9243 350 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
19a31f9c
ML
351}
352
70c7ac22 353#
211b7f19 354# Register submodules in .git/config
70c7ac22
LH
355#
356# $@ = requested paths (default to all)
357#
23a485e3 358cmd_init()
70c7ac22 359{
5c08dbbd
JH
360 # parse $args after "submodule ... init".
361 while test $# -ne 0
362 do
363 case "$1" in
364 -q|--quiet)
2e6a30ef 365 GIT_QUIET=1
5c08dbbd
JH
366 ;;
367 --)
368 shift
369 break
370 ;;
371 -*)
372 usage
373 ;;
374 *)
375 break
376 ;;
377 esac
378 shift
379 done
380
6e7c14e6 381 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
382}
383
cf419828
JL
384#
385# Unregister submodules from .git/config and remove their work tree
386#
cf419828
JL
387cmd_deinit()
388{
389 # parse $args after "submodule ... deinit".
f6a52799 390 deinit_all=
cf419828
JL
391 while test $# -ne 0
392 do
393 case "$1" in
394 -f|--force)
395 force=$1
396 ;;
397 -q|--quiet)
398 GIT_QUIET=1
399 ;;
f6a52799
SB
400 --all)
401 deinit_all=t
402 ;;
cf419828
JL
403 --)
404 shift
405 break
406 ;;
407 -*)
408 usage
409 ;;
410 *)
411 break
412 ;;
413 esac
414 shift
415 done
416
2e612731 417 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
418}
419
fb43e31f 420is_tip_reachable () (
01e1d544 421 sanitize_submodule_env &&
fb43e31f
SB
422 cd "$1" &&
423 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
424 test -z "$rev"
425)
426
427fetch_in_submodule () (
01e1d544 428 sanitize_submodule_env &&
fb43e31f
SB
429 cd "$1" &&
430 case "$2" in
431 '')
432 git fetch ;;
433 *)
6cbf454a
SB
434 shift
435 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
436 esac
437)
438
70c7ac22 439#
211b7f19 440# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
441#
442# $@ = requested paths (default to all)
443#
23a485e3 444cmd_update()
70c7ac22 445{
5c08dbbd
JH
446 # parse $args after "submodule ... update".
447 while test $# -ne 0
448 do
449 case "$1" in
450 -q|--quiet)
2e6a30ef 451 GIT_QUIET=1
5c08dbbd 452 ;;
e84c3cf3
SB
453 -v)
454 GIT_QUIET=0
455 ;;
72c5f883 456 --progress)
c7199e3a 457 progress=1
72c5f883 458 ;;
be4d2c83 459 -i|--init)
d92a3959 460 init=1
be4d2c83 461 ;;
06b1abb5
TK
462 --remote)
463 remote=1
464 ;;
31ca3ac3 465 -N|--no-fetch)
31ca3ac3
FF
466 nofetch=1
467 ;;
9db31bdf
NMC
468 -f|--force)
469 force=$1
470 ;;
ca2cedba 471 -r|--rebase)
32948425 472 update="rebase"
ca2cedba 473 ;;
d92a3959
MT
474 --reference)
475 case "$2" in '') usage ;; esac
476 reference="--reference=$2"
98dbe63d 477 shift
d92a3959
MT
478 ;;
479 --reference=*)
480 reference="$1"
d92a3959 481 ;;
a0ef2934
CF
482 --dissociate)
483 dissociate=1
484 ;;
42b49178 485 -m|--merge)
42b49178
JH
486 update="merge"
487 ;;
b13fd5c1 488 --recursive)
b13fd5c1
JH
489 recursive=1
490 ;;
efc5fb6a
JH
491 --checkout)
492 update="checkout"
493 ;;
abed000a
SB
494 --recommend-shallow)
495 recommend_shallow="--recommend-shallow"
496 ;;
497 --no-recommend-shallow)
498 recommend_shallow="--no-recommend-shallow"
499 ;;
275cd184
FG
500 --depth)
501 case "$2" in '') usage ;; esac
502 depth="--depth=$2"
503 shift
504 ;;
505 --depth=*)
506 depth=$1
507 ;;
2335b870
SB
508 -j|--jobs)
509 case "$2" in '') usage ;; esac
510 jobs="--jobs=$2"
511 shift
512 ;;
513 --jobs=*)
514 jobs=$1
515 ;;
5c08dbbd
JH
516 --)
517 shift
518 break
519 ;;
520 -*)
521 usage
522 ;;
523 *)
524 break
525 ;;
526 esac
98dbe63d 527 shift
5c08dbbd
JH
528 done
529
d92a3959
MT
530 if test -n "$init"
531 then
532 cmd_init "--" "$@" || return
533 fi
534
48308681
SB
535 {
536 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 537 ${progress:+"--progress"} \
48308681
SB
538 ${wt_prefix:+--prefix "$wt_prefix"} \
539 ${prefix:+--recursive-prefix "$prefix"} \
540 ${update:+--update "$update"} \
5f50f33e 541 ${reference:+"$reference"} \
a0ef2934 542 ${dissociate:+"--dissociate"} \
48308681 543 ${depth:+--depth "$depth"} \
c7199e3a
CF
544 $recommend_shallow \
545 $jobs \
c4c02bf1 546 "$@" || echo "#unmatched" $?
48308681 547 } | {
15ffb7cd 548 err=
9eca701f 549 while read -r quickabort sha1 just_cloned sm_path
70c7ac22 550 do
9eca701f 551 die_if_unmatched "$quickabort" "$sha1"
48308681 552
5d124f41 553 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
74d4731d 554
ee69b2a9 555 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
efc5fb6a 556
44431df0 557 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 558
48308681 559 if test $just_cloned -eq 1
d851ffb9 560 then
bf2d8246
LH
561 subsha1=
562 else
14111fc4 563 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 564 git rev-parse --verify HEAD) ||
091a6eb0 565 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 566 fi
211b7f19 567
06b1abb5
TK
568 if test -n "$remote"
569 then
92bbe7cc 570 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
571 if test -z "$nofetch"
572 then
573 # Fetch remote before determining tracking $sha1
6cbf454a 574 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
575 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
576 fi
14111fc4
JK
577 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
578 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 579 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 580 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
581 fi
582
496eeeb1 583 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 584 then
9db31bdf
NMC
585 subforce=$force
586 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 587 if test -z "$subsha1" && test -z "$force"
b9b378a0 588 then
9db31bdf 589 subforce="-f"
b9b378a0 590 fi
31ca3ac3
FF
591
592 if test -z "$nofetch"
593 then
e5f522d6
JL
594 # Run fetch only if $sha1 isn't present or it
595 # is not reachable from a ref.
fb43e31f 596 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 597 fetch_in_submodule "$sm_path" $depth ||
bd5e567d 598 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
fb43e31f
SB
599
600 # Now we tried the usual fetch, but $sha1 may
601 # not be reachable from any of the refs
602 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 603 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 604 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
605 fi
606
877449c1 607 must_die_on_failure=
32948425 608 case "$update_module" in
a2aed08b
TK
609 checkout)
610 command="git checkout $subforce -q"
611 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
612 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
613 ;;
32948425
JH
614 rebase)
615 command="git rebase"
091a6eb0
JK
616 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
617 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 618 must_die_on_failure=yes
32948425 619 ;;
42b49178
JH
620 merge)
621 command="git merge"
091a6eb0
JK
622 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
623 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 624 must_die_on_failure=yes
42b49178 625 ;;
6cb5728c
CP
626 !*)
627 command="${update_module#!}"
b08238ac
SB
628 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
629 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
630 must_die_on_failure=yes
631 ;;
32948425 632 *)
ff03d930 633 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 634 esac
70c7ac22 635
14111fc4 636 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 637 then
ff968f03 638 say "$say_msg"
877449c1
JH
639 elif test -n "$must_die_on_failure"
640 then
ff968f03 641 die_with_status 2 "$die_msg"
15ffb7cd 642 else
ff968f03 643 err="${err};$die_msg"
877449c1 644 continue
15ffb7cd 645 fi
70c7ac22 646 fi
b13fd5c1
JH
647
648 if test -n "$recursive"
649 then
75bf5e60 650 (
44431df0 651 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 652 wt_prefix=
14111fc4 653 sanitize_submodule_env
75bf5e60 654 cd "$sm_path" &&
36141282 655 eval cmd_update
75bf5e60 656 )
15ffb7cd
FG
657 res=$?
658 if test $res -gt 0
659 then
091a6eb0 660 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 661 if test $res -ne 2
15ffb7cd 662 then
ff968f03 663 err="${err};$die_msg"
15ffb7cd
FG
664 continue
665 else
ff968f03 666 die_with_status $res "$die_msg"
15ffb7cd
FG
667 fi
668 fi
b13fd5c1 669 fi
70c7ac22 670 done
15ffb7cd
FG
671
672 if test -n "$err"
673 then
674 OIFS=$IFS
675 IFS=';'
676 for e in $err
677 do
678 if test -n "$e"
679 then
680 echo >&2 "$e"
681 fi
682 done
683 IFS=$OIFS
684 exit 1
685 fi
686 }
70c7ac22
LH
687}
688
b57e8119
DL
689#
690# Configures a submodule's default branch
691#
692# $@ = requested path
693#
694cmd_set_branch() {
695 unset_branch=false
696 branch=
697
698 while test $# -ne 0
699 do
700 case "$1" in
701 -q|--quiet)
702 # we don't do anything with this but we need to accept it
703 ;;
704 -d|--default)
705 unset_branch=true
706 ;;
707 -b|--branch)
708 case "$2" in '') usage ;; esac
709 branch=$2
710 shift
711 ;;
712 --)
713 shift
714 break
715 ;;
716 -*)
717 usage
718 ;;
719 *)
720 break
721 ;;
722 esac
723 shift
724 done
725
726 if test $# -ne 1
727 then
728 usage
729 fi
730
731 # we can't use `git submodule--helper name` here because internally, it
732 # hashes the path so a trailing slash could lead to an unintentional no match
733 name="$(git submodule--helper list "$1" | cut -f2)"
734 if test -z "$name"
735 then
736 exit 1
737 fi
738
739 test -n "$branch"; has_branch=$?
740 test "$unset_branch" = true; has_unset_branch=$?
741
742 if test $((!$has_branch != !$has_unset_branch)) -eq 0
743 then
744 usage
745 fi
746
747 if test $has_branch -eq 0
748 then
749 git submodule--helper config submodule."$name".branch "$branch"
750 else
751 git submodule--helper config --unset submodule."$name".branch
752 fi
753}
754
28f9af5d
PY
755#
756# Show commit summary for submodules in index or working tree
757#
758# If '--cached' is given, show summary between index and given commit,
759# or between working tree and given commit
760#
761# $@ = [commit (default 'HEAD'),] requested paths (default all)
762#
763cmd_summary() {
f2dc06a3 764 summary_limit=-1
d0f64dd4 765 for_status=
1c244f6e 766 diff_cmd=diff-index
f2dc06a3 767
28f9af5d
PY
768 # parse $args after "submodule ... summary".
769 while test $# -ne 0
770 do
771 case "$1" in
772 --cached)
773 cached="$1"
774 ;;
1c244f6e
JL
775 --files)
776 files="$1"
777 ;;
d0f64dd4
PY
778 --for-status)
779 for_status="$1"
780 ;;
f2dc06a3 781 -n|--summary-limit)
862ae6cd
RS
782 summary_limit="$2"
783 isnumber "$summary_limit" || usage
f2dc06a3
PY
784 shift
785 ;;
862ae6cd
RS
786 --summary-limit=*)
787 summary_limit="${1#--summary-limit=}"
788 isnumber "$summary_limit" || usage
789 ;;
28f9af5d
PY
790 --)
791 shift
792 break
793 ;;
794 -*)
795 usage
796 ;;
797 *)
798 break
799 ;;
800 esac
801 shift
802 done
bffe71f4 803
f2dc06a3
PY
804 test $summary_limit = 0 && return
805
3deea89c 806 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
807 then
808 head=$rev
caa9c3ca 809 test $# = 0 || shift
496eeeb1 810 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 811 then
14e940d7
JH
812 # before the first commit: compare with an empty tree
813 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 814 test -z "$1" || shift
28f9af5d 815 else
3deea89c 816 head="HEAD"
28f9af5d
PY
817 fi
818
1c244f6e
JL
819 if [ -n "$files" ]
820 then
821 test -n "$cached" &&
465d6a00 822 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
823 diff_cmd=diff-files
824 head=
825 fi
826
28f9af5d 827 cd_to_toplevel
091a6eb0 828 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 829 # Get modified modules cared by user
18076502 830 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 831 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 832 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
833 do
834 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
835 if test "$status" = D || test "$status" = T
836 then
6a066230 837 printf '%s\n' "$sm_path"
496eeeb1
EP
838 continue
839 fi
927b26f8 840 # Respect the ignore setting for --for-status.
841 if test -n "$for_status"
842 then
0ea306ef 843 name=$(git submodule--helper name "$sm_path")
927b26f8 844 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 845 test $status != A && test $ignore_config = all && continue
927b26f8 846 fi
28f9af5d 847 # Also show added or modified modules which are checked out
974ce807 848 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 849 printf '%s\n' "$sm_path"
28f9af5d
PY
850 done
851 )
1cb639e6 852
d0f64dd4
PY
853 test -z "$modules" && return
854
18076502 855 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 856 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 857 cut -c2- |
cf9e55f4 858 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
859 do
860 if test -z "$cached" &&
dda63468 861 is_zero_oid $sha1_dst
1cb639e6
PY
862 then
863 case "$mod_dst" in
864 160000)
865 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
866 ;;
867 100644 | 100755 | 120000)
868 sha1_dst=$(git hash-object $name)
869 ;;
870 000000)
871 ;; # removed
872 *)
873 # unexpected type
6ff875c5 874 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
875 continue ;;
876 esac
877 fi
878 missing_src=
879 missing_dst=
880
881 test $mod_src = 160000 &&
974ce807 882 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
883 missing_src=t
884
885 test $mod_dst = 160000 &&
974ce807 886 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 887 missing_dst=t
bffe71f4 888
44431df0 889 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 890
1cb639e6
PY
891 total_commits=
892 case "$missing_src,$missing_dst" in
893 t,)
091a6eb0 894 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
895 ;;
896 ,t)
091a6eb0 897 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
898 ;;
899 t,t)
091a6eb0 900 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
901 ;;
902 *)
903 errmsg=
904 total_commits=$(
496eeeb1 905 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
906 then
907 range="$sha1_src...$sha1_dst"
908 elif test $mod_src = 160000
909 then
910 range=$sha1_src
911 else
912 range=$sha1_dst
913 fi
914 GIT_DIR="$name/.git" \
b0e621ad 915 git rev-list --first-parent $range -- | wc -l
1cb639e6 916 )
eed35595 917 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
918 ;;
919 esac
920
0586a438
SH
921 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
922 echo $sha1_src | cut -c1-7)
923 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
924 echo $sha1_dst | cut -c1-7)
925
1cb639e6
PY
926 if test $status = T
927 then
b3e73449
ÆAB
928 blob="$(gettext "blob")"
929 submodule="$(gettext "submodule")"
1cb639e6
PY
930 if test $mod_dst = 160000
931 then
091a6eb0 932 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 933 else
091a6eb0 934 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
935 fi
936 else
091a6eb0 937 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
938 fi
939 if test -n "$errmsg"
940 then
941 # Don't give error msg for modification whose dst is not submodule
942 # i.e. deleted or changed to blob
943 test $mod_dst = 160000 && echo "$errmsg"
944 else
496eeeb1 945 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 946 then
f2dc06a3
PY
947 limit=
948 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 949 GIT_DIR="$name/.git" \
f2dc06a3 950 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
951 --first-parent $sha1_src...$sha1_dst
952 elif test $mod_dst = 160000
953 then
954 GIT_DIR="$name/.git" \
955 git log --pretty='format: > %s' -1 $sha1_dst
956 else
957 GIT_DIR="$name/.git" \
958 git log --pretty='format: < %s' -1 $sha1_src
959 fi
960 echo
961 fi
962 echo
3ba7407b 963 done
28f9af5d 964}
70c7ac22 965#
941987a5 966# List all submodules, prefixed with:
70c7ac22
LH
967# - submodule not initialized
968# + different revision checked out
969#
970# If --cached was specified the revision in the index will be printed
971# instead of the currently checked out revision.
972#
973# $@ = requested paths (default to all)
974#
23a485e3 975cmd_status()
70c7ac22 976{
5c08dbbd
JH
977 # parse $args after "submodule ... status".
978 while test $# -ne 0
979 do
980 case "$1" in
981 -q|--quiet)
2e6a30ef 982 GIT_QUIET=1
5c08dbbd
JH
983 ;;
984 --cached)
985 cached=1
986 ;;
64b19ffe
JH
987 --recursive)
988 recursive=1
989 ;;
5c08dbbd
JH
990 --)
991 shift
992 break
993 ;;
994 -*)
995 usage
996 ;;
997 *)
998 break
999 ;;
1000 esac
1001 shift
1002 done
1003
a9f8a375 1004 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 1005}
2327f61e
DA
1006#
1007# Sync remote urls for submodules
1008# This makes the value for remote.$remote.url match the value
1009# specified in .gitmodules.
1010#
1011cmd_sync()
1012{
1013 while test $# -ne 0
1014 do
1015 case "$1" in
1016 -q|--quiet)
2e6a30ef 1017 GIT_QUIET=1
2327f61e
DA
1018 shift
1019 ;;
82f49f29
PH
1020 --recursive)
1021 recursive=1
1022 shift
1023 ;;
2327f61e
DA
1024 --)
1025 shift
1026 break
1027 ;;
1028 -*)
1029 usage
1030 ;;
1031 *)
1032 break
1033 ;;
1034 esac
1035 done
e7849a96 1036
13424764 1037 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 1038}
70c7ac22 1039
f6f85861
SB
1040cmd_absorbgitdirs()
1041{
1042 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1043}
1044
5c08dbbd
JH
1045# This loop parses the command line arguments to find the
1046# subcommand name to dispatch. Parsing of the subcommand specific
1047# options are primarily done by the subcommand implementations.
1048# Subcommand specific options such as --branch and --cached are
1049# parsed here as well, for backward compatibility.
1050
1051while test $# != 0 && test -z "$command"
70c7ac22
LH
1052do
1053 case "$1" in
b57e8119 1054 add | foreach | init | deinit | update | set-branch | status | summary | sync | absorbgitdirs)
5c08dbbd 1055 command=$1
70c7ac22
LH
1056 ;;
1057 -q|--quiet)
2e6a30ef 1058 GIT_QUIET=1
70c7ac22 1059 ;;
ecda0723
SV
1060 -b|--branch)
1061 case "$2" in
1062 '')
1063 usage
1064 ;;
1065 esac
1066 branch="$2"; shift
1067 ;;
70c7ac22 1068 --cached)
28f9af5d 1069 cached="$1"
70c7ac22
LH
1070 ;;
1071 --)
1072 break
1073 ;;
1074 -*)
1075 usage
1076 ;;
1077 *)
1078 break
1079 ;;
1080 esac
1081 shift
1082done
1083
5c08dbbd 1084# No command word defaults to "status"
af9c9f97
RR
1085if test -z "$command"
1086then
1087 if test $# = 0
1088 then
1089 command=status
1090 else
1091 usage
1092 fi
1093fi
5c08dbbd 1094
b57e8119
DL
1095# "-b branch" is accepted only by "add" and "set-branch"
1096if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
5c08dbbd 1097then
ecda0723 1098 usage
5c08dbbd
JH
1099fi
1100
28f9af5d 1101# "--cached" is accepted only by "status" and "summary"
496eeeb1 1102if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1103then
70c7ac22 1104 usage
5c08dbbd
JH
1105fi
1106
b57e8119 1107"cmd_$(echo $command | sed -e s/-/_/g)" "$@"